#include <stdio.h>
#include <stdlib.h>
#include <time.h>

const int n = 900000;

int main()
{
    double v1[n], val;
    int i, iter, ret, seekw;
    FILE *fp;
    time_t ti, tf;
    long pos, l;

    fp = fopen("out.dat", "w+b");
    if (fp == NULL) {
      fprintf(stderr, "Could not open output file\n");
      exit(EXIT_FAILURE);
    }

    for (i = 0; i < n; i++)
	    v1[i] = rand() / ((double) RAND_MAX);
    printf("First element is %lf\n", v1[0]);

    ret = 0;
    time(&ti);
    for (iter = 1; iter <= 10; iter++) {
      /* Write an element at a time */
      for(i = 0; i < n; i++) {
        fprintf(fp,"%.19lf",v1[i]); // for ASCII output
        ret += fwrite(v1+i, sizeof(double), 1, fp); // for binary output
      }

      ret += fwrite(v1, sizeof(double), n, fp);
    }
    time(&tf);

    if (ret != n * 10) {
      fprintf(stderr, "fwrite failed\n");
      exit(EXIT_FAILURE);
    }
    printf("%lf seconds\n", difftime(tf, ti));

    /* And now let's read first element of each copy of the array we just wrote
     * (binary output only) */
    l = 0L;
    seekw = SEEK_SET;
    for (i = 0; i < 10L; i++) {
      ret = fseek(fp, l, seekw);
      if (ret != 0) {
	      fprintf(stderr, "fseek failed\n");
	      exit(EXIT_FAILURE);
    	}

      ret = fread(&val, sizeof(double), 1, fp);
      if (ret != 1) {
        fprintf(stderr, "fread failed.\n");
        exit(EXIT_FAILURE);
      }

      pos = ftell(fp);
      printf("Iteration %d, position=%ld, value=%lf\n", i + 1, pos, val);
      l = (n - 1) * sizeof(double);
      seekw = SEEK_CUR;
    }

    return 0;
}
