#include <stdlib.h>
#include <stdio.h>
#include <math.h>

double f(double x) {
    return cos(x);
}

#define EPSILON 1.e-6

int main () {

  double a, b, c, delta;
  printf("\nUse Bisection method to find root of\n");
  printf("f(x)=0 in (a,b)\n");

  printf("\nPlease enter a, b: ");
  scanf("%lf, %lf", &a, &b);

  if ( f(a) * f(b) > 0) {
    fprintf(stderr,"\nf(a) has the same sign as f(b), bisection would not work.\n");
    exit(EXIT_FAILURE);
  }

  if (a > b) {
    c = a;
    a = b;
    b = c;
  }

  do {

    double p;
    c = 0.5 * (a + b);
    p = f(a) * f(c);
    if (p > 0.0) {
      a = c;
    } else if (p < 0.0) {
      b = c;
    } else {
      break; // c is our root
    }

    delta = fabs(a - b);

  } while (delta > EPSILON);

  printf("\nRoot found at %lf\n", c);

  return 0;
}
