/* Reads text lines from standard input until 
 * an empty line is entered; then prints an 
 * histogram of characters. 
*/ 

#include <stdio.h>
#include <ctype.h>

int main()
{
	unsigned char *line = NULL;
	size_t len = 0;
	size_t read;
	int i, hist[256];

	for( len=0; len<256; len++) 
		hist[len] = 0;        

	while (((read = getline(&line, &len, stdin)) != 1)) {
		unsigned char *c;
		for( c=line; c<line+read; c++) 
			hist[*c] ++;
	}

	printf("Character histogram:\n");
	printf("ASCII code Character Count\n");
	for(i=0;i<256;i++) { 
		if( hist[i]) {
			if(isprint(i)) 
				printf("%-9d %-9c %-d\n",i, i, hist[i]);
			else
				printf("%-9d --------- %-d\n",i, hist[i]);
		}
	}

	return 0;
}
