/* Compute the product of matrix A and B 
 * using the GEMM function from the cblas 
 * library. 
*/

#include <stdio.h>
#include <gsl_cblas.h>
#include "linear_algebra.h" // just to print matrices

int main (void) {
  const int n = 3;
  const int m = 2;
  const int k = 3;

  int i, j;
  double a[n][k];
  double b[k][m];
  double c[n][m];
	const int lda = n;
	const int ldb = k;
	const int ldc = n;

  /* initialize A B and V*/
  for(i=0;i<n;i++) { 
      for(j=0;j<k;j++) {
          a[i][j] = (double) (i*j);
      }
  }

  for(i=0;i<k;i++) {
      for(j=0;j<m;j++) {
          b[i][j] = (double)(i+j);
      }
  }

  printf("\nMatrix A:");
  printMatrix(n,k, (double *) a);
  printf("\nMatrix B:");
  printMatrix(k,m, (double *) b);

  /* Compute C = A B */
	cblas_dgemm (CblasRowMajor, CblasNoTrans, CblasNoTrans, 
        n, m, k, 1.0, (double *) a, lda, (double *) b, ldb, 
        0.0, (double *) c, ldc);
  
  printf("\nMatrix C:");
  printMatrix(k,m, (double *) c);

	return 0;
}
