/* Generates random numbers in the range 0,1, computes their average, and 
 * builds an histogram with ninterv bin   
*/ 

#include <stdio.h>
#include <stdlib.h>

#define NITER (10000000)
const int ninterv = 10;

int main() {
   int i, ind;
   double val, avg = 0.0, tic = 1.0/ninterv;
   int hist[ninterv];

   for (i=0; i<ninterv; ++i) 
      hist[i] = 0;
    
   for (i=0; i<NITER;++i) {
      val = rand()/((double)RAND_MAX);
      ind = val/tic;
      hist[ind]++;
      avg += val;
   }
   avg /= NITER;
   printf("Average on %d values is %lf\n",NITER, avg);

   printf("Histogram:\n");
   val = 0.0;
   for(i=0;i<ninterv;i++) {
      double hval = hist[i] / ((double)NITER); 
      printf("%lf %lf\n", val,hval);
      val += tic;
   }

  return 0;
}
