/* Exercise: Pi
 *
 * In this exercise you will determine the value 
 * of PI using the integral of 
 *    4/(1+x*x) between 0 and 1
 *
 * The integral is approximated by a sum of n intervals.
 * 
 * The approximation to the integral in each interval is:
 *    (1/n)*4/(1+x*x). 
 */

#include <stdio.h>
#include <math.h>

#define INTERVALS 1000

double f(double x) {
    return 4.0 / (1.0 + x*x);
}

int main(int argc, char **argv)
{
    int i;
    int intervals = INTERVALS;
    double lower, upper;
    double x, dx, sum;
    
    lower = 0.0;
    upper = 1.0;
    dx = (upper - lower) / intervals;
    
    sum = 0.0;
    for (i = 0; i < intervals; ++i) {
        x = dx * (i + 0.5);
        sum = sum + f(x)*dx;
    }

    printf("\nComputed PI %.24f\n", sum);
    printf("The true PI %.24f\n", M_PI);
    printf("Difference  %12.6E\n\n", sum-M_PI);

    return 0;
}
