#include <stdio.h>
#include "linear_algebra.h"

double trace(int nrow, const double *matr) {
    int i;
    double tr = 0.0;        

    for( i=0; i<nrow; i++) 
        tr += matr[nrow*i+i];

    return tr;
}

void dmatrix_vector(int n, int m, 
  const double *a, 
  const double *v, 
  double *c) 
{
    int i, j;
    for(i=0; i<n; i++) {
            c[i] = 0.0;
        for(j=0; j<m; j++) {
            c[i] += a[m*i+j]*v[j];
        }
    }
}

void dmatrix_matrix(
  int n, // rows of A
  int m, // columns of B
  int l, // colums of A or rows of B
  const double *a, 
  const double *b, 
  double *c) 
{
    int i, j, k;
    for(i=0; i<n; i++) {
        for(j=0; j<m; j++) {
            c[m*i+j]=0.0;
            for(k=0; k<l; k++) 
                c[m*i+j] += a[l*i+k]*b[m*j+k];
        }
    }
}

void printMatrix(int n, int m, 
  const double *a)
{
    int i, j;
    printf("\n");
    for(i=0; i<n; i++) {
        for(j=0; j<m; j++)
            printf("%8g ", a[m*i+j]);
        printf("\n");
    }
}

void printVector(int n, 
  const double *a)
{
    int i;
    printf("\n");
    for(i=0; i<n; i++) {
        printf("%8g ", a[i]);
    }
    printf("\n");
}
