#include <stdio.h>
#include "linear_algebra_vla.h"

double trace(int nrow, const double matr[nrow][nrow]) {
    int i;
    double tr = 0.0;        

    for( i=0; i<nrow; i++) 
        tr += matr[i][i];

    return tr;
}

void dmatrix_vector(int lda, int ldb, 
  const double a[lda][ldb], 
  const double v[ldb], 
  double c[ldb]) 
{
    int i, j;
    for(i=0; i<lda; i++) {
            c[i] = 0.0;
        for(j=0; j<ldb; j++) {
            c[i] += a[i][j]*v[j];
        }
    }
}

void dmatrix_matrix(int lda, int ldb, int ldc, 
  const double a[lda][ldb], 
  const double b[ldb][ldc], 
  double c[lda][ldc]) 
{
    int i, j, k;
    for(i=0; i<lda; i++) {
        for(j=0; j<ldc; j++) {
            c[i][j]=0.0;
            for(k=0; k<ldb; k++) 
                c[i][j] += a[i][k]*b[k][j];
        }
    }
}

void printMatrix(int lda, int ldb, 
  const double a[][ldb])
{
    int i, j;
    printf("\n");
    for(i=0; i<lda; i++) {
        for(j=0; j<ldb; j++)
            printf("%8g ", a[i][j]);
        printf("\n");
    }
}

void printVector(int lda, 
  const double a[lda])
{
    int i;
    printf("\n");
    for(i=0; i<lda; i++) {
        printf("%8g ", a[i]);
    }
    printf("\n");
}
