/* Write functions that computes: 
 * the trace of a matrix A
 * the product of a matrix A by vector V
 * the product of a matrix A by matrix B
 * 
 * Write also a function to print a matrix
 * so to use it to check input and results
 *
 * initialize a matrixes and vector as: 
 * A(i,j) = i*j
 * B(i,j) = i+j
 * V(i) = i
*/
 
#include <stdio.h>
#include <errno.h>
#include "linear_algebra.h"

int main() 
{
    const int n = 3;
    const int k = 3;
    const int m = 2;

    int i, j;
    double a[n][k];
    double b[k][m];
    double c[n][m];
    double v[k], vv[k];
    double tr;

    /* initialize A B and V*/
    for(i=0;i<n;i++) { 
        for(j=0;j<k;j++) {
            a[i][j] = (double) (i*j);
        }
    }

    for(i=0;i<k;i++) {
        for(j=0;j<m;j++) {
            b[i][j] = (double)(i+j);
        }
    }

    for(i=0;i<k;i++) {
        v[i] = (double) i;
    }
    printf("\nMatrix A:");
    printMatrix(n,k, (double *) a);
    printf("\nMatrix B:");
    printMatrix(k,m, (double *) b);
    printf("\nVector C:");
    printVector(k, (double *) v);

    /* trace of matrix A */
    if (n == k) {
        tr = trace(n, (double *) a);
        printf("\nTrace[A] = %lf\n", tr);
    }
    if (k == m) {
        tr = trace(k, (double *) b);
        printf("\nTrace[B] = %lf\n", tr);
    }

    /* product of matrix A with vector V */
    dmatrix_vector(n, k, (double *) a, (double *) v, (double *) vv);
    printf("\nA*V:");
    printVector(k, (double *) vv);

    /* product of matrix A with matrix B */
    dmatrix_matrix(n, m, k, (double *) a, (double *) b, (double *) c);
    printf("\nA*B:");
    printMatrix(n, m, (double *) c);
    if (n == m) {
        tr = trace(m, (double *) c);
        printf("\nTrace[C] = %lf\n", tr);
    }

    return 0;
}
