/* Write functions that computes: 
 * the trace of a matrix A
 * the product of a matrix A by vector V
 * the product of a matrix A by matrix B
 * 
 * Write also a function to print a matrix
 * so to use it to check input and results
 *
 * initialize a matrixes and vector as: 
 * A(i,j) = i*j
 * B(i,j) = i+j
 * V(i) = i
*/
 
#include <stdio.h>
#include <errno.h>
#include "linear_algebra_vla.h"

int main() 
{
    const int lda = 3;
    const int ldb = 3;
    const int ldc = 2;

    int i, j;
    double a[lda][ldb];
    double b[ldb][ldc];
    double c[lda][ldc];
    double v[ldb], vv[ldb];
    double tr;

    /* initialize A B and V*/
    for(i=0;i<lda;i++) { 
        for(j=0;j<ldb;j++) {
            a[i][j] = (double) (i*j);
        }
    }

    for(i=0;i<ldb;i++) {
        for(j=0;j<ldc;j++) {
            b[i][j] = (double)(i+j);
        }
    }

    for(i=0;i<ldb;i++) {
        v[i] = (double) i;
    }
    printf("\nMatrix A:");
    printMatrix(lda,ldb,a);
    printf("\nMatrix B:");
    printMatrix(ldb,ldc,b);
    printf("\nVector C:");
    printVector(ldb,v);

    /* trace of matrix A */
    if (lda == ldb) {
        tr = trace(lda, a);
        printf("\nTrace[A] = %lf\n", tr);
    }
    if (ldb == ldc) {
        tr = trace(ldb, b);
        printf("\nTrace[B] = %lf\n", tr);
    }

    /* product of matrix A with vector V */
    dmatrix_vector(lda, ldb, a, v, vv);
    printf("\nA*V:");
    printVector(ldb, vv);

    /* product of matrix A with matrix B */
    dmatrix_matrix(lda, ldb, ldc, a, b, c);
    printf("\nA*B:");
    printMatrix(lda, ldc, c);
    if (lda == ldc) {
        tr = trace(ldc, c);
        printf("\nTrace[C] = %lf\n", tr);
    }

    return 0;
}
