#include <stdio.h>
#include <stdlib.h> // defines rand() and RAND_MAX
#include "math.h"

int main() {
    long long tries, inside, N;
    double estimate;
    const double rand_norm = 1.0/(RAND_MAX + 1.0);
    
    printf("\nMC estimate of pi\n");

    printf("Set maximum number of iterations: ");
    scanf("%lld", &N);

    inside = tries = 0;
    do {
      double x, y;
      tries++;
      x = rand_norm*rand();
      y = rand_norm*rand();
      if ( x*x + y*y < 1.0 ) inside++;
    } while ( tries < N);

    // multiply by 4 since we have considered
    // just one quadrant (0<x<1, 0<y<1)
    estimate = 4.0 * inside/((double) tries);

    printf("Computed estimate %.8lg±%.8lg\n", 
        estimate, sqrt(1.0/tries));

    return 0;
}
