/* Discovering size and range of some integer and floating-point types */ 

#include <stdio.h>
#include <limits.h>
#include <float.h>

int main() {
	printf("Integer types: \n");
	printf("\n");
	printf("Type     \tSize \tMinimum \tMaximum\n");
	printf("Short    \t%-5d\t%-hd\t%-hd\n",sizeof(short),SHRT_MIN,SHRT_MAX);
	printf("int      \t%-5d\t%-d\t%-d\n",sizeof(int),INT_MIN,INT_MAX);
	printf("Long     \t%-5d\t%-ld\t%-ld\n",sizeof(long),LONG_MIN,LONG_MAX);
	printf("Long long\t%-5d\t%-lld\t%-lld\n", \
		sizeof(long long),LLONG_MIN,LLONG_MAX);
	printf("Maximum values for unsigned int types:\n");
	printf("Type              \tMaximum value\n");
	printf("Unsigned short	  \t%-hu\n",USHRT_MAX);
	printf("Unsigned int  	  \t%-u\n",UINT_MAX);
	printf("Unsigned long 	  \t%-lu\n",ULONG_MAX);
	printf("Unsigned long long\t%-llu\n",ULLONG_MAX);
	printf("\n");

	printf("Floating-point  types: \n");
	printf("Type     \tSize \tMinimum \tMaximum\n");
	printf("float      \t%-5d\t%-G\t%-G\n",sizeof(float),FLT_MIN,FLT_MAX);
	printf("double     \t%-5d\t%-lG\t%-lG\n", \
		sizeof(double),DBL_MIN,DBL_MAX);
	printf("long double\t%-5d\t%-llG\t%-llG\n", \
		sizeof(long double),LDBL_MIN,LDBL_MAX);
	printf("\n");

	printf("Type          \tSignificant digits\n");
	printf("float         \t%d\n",FLT_DIG);
	printf("double        \t%d\n",DBL_DIG);
	printf("long double   \t%d\n",LDBL_DIG);
	printf("\n");
}
