#include <stdio.h>
#include <stdlib.h>

void printArray(int size, double data[size])
{
   int i;
   for (i=0;i<size;i++) 
      printf("%.2lf ", data[i]);
   printf("\n");
}
  
#define NITER (2)
const int size=20;

int main() {
   int i, j, k, ns;
   double data[size], wrk[size];

   // initialize array
   for ( i=0; i<size; i++) 
      data[i] = i+1;

   printf("Enter the number of smoothing points, array size is %d:\n", size);
   scanf("%d", &ns);

   if (ns > size) {
      fprintf(stderr, "Error: More smoothing points than array elements.\n");
      exit(1);
   }

   printf("\nInitial values:\n");
   printArray(size, data);

   for (i=1; i<=NITER; i++) {

     double norm = 1.0/(2.0*ns+1);

     for (j=0; j<size; j++) {
        wrk[j] = 0.0;
        for (k=j-ns; k<=j+ns; k++) 
           wrk[j] = wrk[j] + data[(size+k)%size];
     }

     for (j=0; j<size; j++) {
        data[j] = norm * wrk[j];
     }   

     printArray(size, data);
   }

   return 0;
}   
